<?php

namespace App\Http\Controllers\Admin;

use App\About;
use App\Course;
use App\Http\Requests\LessonRequest;
use App\Lesson;
use Exception;
use Illuminate\View\View;
use Illuminate\Http\Request;
use Illuminate\Http\JsonResponse;
use Illuminate\Routing\Redirector;
use App\Http\Controllers\Controller;
use App\Http\Requests\AboutRequest;
use Illuminate\Http\RedirectResponse;

class LessonController extends Controller
{

    /** Redirect to this path after each operation success*/
    private $redirectSuccessPath= '/admin/lessons';
    /** View folder */
    private $viewDirectory= 'admin.lessons.';

    /**
     * Display a listing of the resource.
     *
     * @param Request $request
     * @return View
     */
    public function index(Request $request) :View
    {
        $title= __('lessons.head');
        $request= $request->toArray();
        return view($this->viewDirectory.'index',compact('title'));
    }

    /**
     * return data of the pages.
     *
     * @param Request $request
     * @return View
     */
    public function grid(Request $request) :View
    {
        $query = Lesson::latest();

        if ($request->date_from) {
            $query->whereDate('created_at', '>=', $request->date_from);
        }

        if ($request->date_to) {
            $query->whereDate('created_at', '<=', $request->date_to);
        }

        if ($request->name) {
            $query->where('name', 'LIKE', '%'.$request->name.'%');
        }

        if ( !is_null($request->status) && $request->status == 0) {
            $query->onlyTrashed();
        }

        $lessons= $query->paginate(100);

        return view($this->viewDirectory.'grid',compact('lessons'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return View
     */
    public function create() :View
    {
        $action= route('lessons.store');
        $head= metaFields('lessons', 'add_new', getCurrentLocale()) ?? __('lessons.new');
        return view( $this->viewDirectory.'form', compact('action', 'head') );
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param AboutRequest $request
     * @return RedirectResponse|Redirector
     */
    public function store(LessonRequest $request) :RedirectResponse
    {
        $name = [];
        foreach (languages() as $language) {
            $name_attr = [
                'name_'.$language->local => $request['name_'.$language->local]
            ];
            $name = array_merge($name, $name_attr);
        }

//        $url = parseExternalVideoLink($request->url);

        Lesson::create([
            'name' => $name,
            'url' => $request->url, //$url['url'],
            'course_id' => $request->course_id,
            'unit_id' => $request->course_id,
        ]);

        return redirect($this->redirectSuccessPath)->with('message', __('dashboard.saveDone'));
    }


    /**
     * Show the form for editing the specified resource.
     *
     * @param Lesson $lesson
     * @return View
     */
    public function edit(Lesson $lesson) :View
    {
        $action= route('lessons.update', $lesson->id);
        $head= metaFields('lessons', 'edit', getCurrentLocale()) ?? __('lessons.edit');
        $unit = $lesson->unit;
        return view( $this->viewDirectory.'form', compact('lesson', 'action', 'head', 'unit') );
    }

    /**
     * Update the specified resource in storage.
     *
     * @param LessonRequest $request
     * @param Lesson $lesson
     * @return RedirectResponse|Redirector
     */
    public function update(LessonRequest $request, Lesson $lesson ) :RedirectResponse
    {
        $name = [];
        foreach (languages() as $language) {
            $name_attr = [
                'name_'.$language->local => $request['name_'.$language->local]
            ];
            $name = array_merge($name, $name_attr);
        }

//        $url = parseExternalVideoLink($request->url);

        $lesson->update([
            'name' => $name,
            'url' => $request->url, //$url['url'],
            'course_id' => $request->course_id,
            'unit_id' => $request->course_id,
        ]);
        return redirect($this->redirectSuccessPath)->with('message', __('dashboard.saveDone'));
    }


    public function getCourseUnit(Request $request)
    {
        if ($request->ajax() && $request->course_id){
            $course = Course::find($request->course_id);
            $units = $course->units;
            return view($this->viewDirectory.'get_course_unites', compact('units'));
        }
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param Request $request
     * @param int $id
     * @return JsonResponse
     * @throws Exception
     */
    public function destroy(Request $request, int $id) :JsonResponse
    {
        $about = Lesson::withTrashed()->find($id);
        if ($about) {
            if ($about->deleted_at) {
                $about->forceDelete();
            } else {
                $about->delete();
            }
            return response()->json(['message'=> __('dashboard.deletedDone')]);
        } else{
            return response()->json(['message'=> __('dashboard.noResult')], 400);
        }
    }

    /**
     * Remove several pages by IDs.
     *
     * @param Request $request
     * @return JsonResponse
     */
    public function destroyAll(Request $request) :JsonResponse
    {
        $ids= $request->ids;
        if ($request->force) {
            Lesson::onlyTrashed()->whereIn('id', $ids)->forceDelete();
        } else {
            Lesson::whereIn('id', $ids)->delete();
        }

        return response()->json(['message'=> __('dashboard.deletedDone')]);
    }

    /**
     * Restore the specified category from storage
     *
     * @param Request $request
     * @param int $id
     * @return JsonResponse
     */
    public function restore(Request $request, int $id) :JsonResponse
    {
        $about = Lesson::withTrashed()->find($id);

        if ($about){
            $about->restore();
            return response()->json(['message'=> __('dashboard.saveDone')]);
        }
        return response()->json(['message'=> __('dashboard.noResult')], 400);
    }

    /**
     * Restore several pages by IDs.
     *
     * @param Request $request
     * @return JsonResponse
     */
    public function restoreAll(Request $request) :JsonResponse
    {
        $about = Lesson::whereIn('id', $request->ids)->onlyTrashed();
        if ($about){
            $about->restore();
            return response()->json(['message'=> __('dashboard.saveDone')]);
        }
    }
}
